export interface StylusState {
    x: number;
    y: number;
    pressure: number;
    tangentialPressure: number;
    tiltX: number;
    tiltY: number;
    twist: number;
}
interface XY {
    x: number;
    y: number;
}
export declare function getStylusState(e: PointerEvent, transformXy?: (xy: XY) => XY): {
    pressure: number;
    tangentialPressure: number;
    tiltX: number;
    tiltY: number;
    twist: number;
    x: number;
    y: number;
};
export declare function createStylusState(): StylusState;
export declare function createStylusStates(length: number, prototype?: Readonly<StylusState>): StylusState[];
export declare function cloneStylusState(stylusState: Readonly<StylusState>): StylusState;
export declare function copyStylusState(dst: StylusState, src: Readonly<StylusState>): void;
export declare function interpolateStylusState(target: StylusState, to: Readonly<StylusState>, t: number): void;
export {};
